	include	"flib.h"
	include	"tios.h"
;	include	"mzlib.h"
	xdef	_main
	xdef	_comment

_main:
	jsr flib::zap_screen
	move.w #1,-(a7)
	jsr tios::FontSetSys
	move.w #4,-(a7)
	pea _comment(pc)
	move.l #$200030,-(a7)
	jsr tios::DrawStrXY
	lea 12(a7),a7
	jsr flib::idle_loop
	move.w #1,d7
start:
	add.w #2,d7
	jsr flib::zap_screen
	lea scr(pc),a0
	clr.l (a0)
	clr.l 4(a0)
	clr.l 8(a0)
	clr.l 12(a0)
	move.w #67,d6
	move.w d7,d5
;a border surrounds the playing field:
	lea $4716,a3
	move.l #0,d1
	move.l #0,d2
b1:
	lea cur(pc),a1
	bsr sprite
	addi.w #1,d1
	cmpi.w #18,d1
	bne b1
	move.w #2,d2
	move.w #17,d1
b2:
	lea cur(pc),a1
	bsr sprite
	addi.w #2,d2
	cmpi.w #18,d2
	bne b2
	move.w #0,d1
	move.w #2,d2
b3:
	lea cur(pc),a1
	bsr sprite
	addi.w #2,d2
	cmpi.w #18,d2
	bne b3
	move.w #0,d1
b4:
	lea cur(pc),a1
	bsr sprite
	addi.w #1,d1
	cmpi.w #18,d1
	bne b4
	lea $4807,a3
make:
	move.l #128,d0
	jsr flib::random
	bsr change
	subi.w #1,d5
      bne make
cursor:
	move.w d6,d1	;x:d1
	move.w d6,d2	;y:d2
	lsr.w #4,d2
	lsl.w #1,d2
	andi.w #$f,d1
	lea cur(pc),a1
	bsr sprite
getkey:
	jsr flib::idle_loop
	cmpi.w #300,d0
	bge move
	cmpi.w #264,d0
	beq quit
	cmpi.w #13,d0
	bne getkey
	move.w d6,d0
	bsr change
	tst.l (a0)
	bne getkey
	tst.l 4(a0)
	bne getkey
	tst.l 8(a0)
	bne getkey
	tst.l 12(a0)
	bne getkey
	bra start
move:
	lea cur(pc),a1
	bsr sprite
	cmpi.w #340,d0
	beq right
	cmpi.w #344,d0
	beq down
	cmpi.w #338,d0
	beq up
	cmpi.w #337,d0
	beq left
;	jsr mzlib::check
	bra cursor
up:
	cmpi.w #0,d2
	beq cursor
	subi.w #16,d6
	bra cursor
down:
	cmpi.w #14,d2
	beq cursor
	addi.w #16,d6
	bra cursor
left:
	cmpi.w #0,d1
	beq cursor
	subi.w #1,d6
	bra cursor
right:
	cmpi.w #15,d1
	beq cursor
	addi.w #1,d6
	bra cursor
quit:
	rts

change:
	move.l d0,d1	;x:d1
	move.l d0,d2	;y:d2
	lsr.w #3,d2
	andi.w #$f,d1
	eori.w #$f,d1
	bchg.b d1,0(a0,d2.w)
	eori.w #$f,d1
	bclr.b #0,d2
;
	lea array(pc),a1
	bsr sprite
;
cup:
	cmpi.w #0,d2
	beq cdown
	subi.w #2,d2
;	bchg.w d1,0(a0,d2.w)
;
	lea array(pc),a1
	bsr sprite
;
	addi.w #2,d2
cdown:
	cmpi.w #14,d2
	beq cleft
	addi.w #2,d2
;	bchg.w d1,0(a0,d2.w)
;
	lea array(pc),a1
	bsr sprite
;
	subi.w #2,d2
cleft:
	cmpi.w #0,d1
	beq cright
	subi.w #1,d1
;	bchg.w d1,0(a0,d2.w)
;
	lea array(pc),a1
	bsr sprite
;
	addi.w #1,d1
cright:
	cmpi.w #15,d1
	beq done
	addi.w #1,d1
;	bchg.w d1,0(a0,d2.w)
;
	lea array(pc),a1
	bsr sprite
;
	subi.w #1,d1
done:
	rts

sprite:
	move.l a3,a2
	move.l d2,d3
	mulu #120,d3
	add.l d3,a2
	add.l d1,a2
	move.b #8,d4
sloop:
	move.b (a1)+,d3
	eor.b d3,(a2)
	lea 30(a2),a2
	subi.b #1,d4
	bne sloop
	rts

scr	ds.l 4

array:
	dc.b    %00011000
	dc.b    %00111100
	dc.b    %01110110
	dc.b    %11111011
	dc.b    %11111111
	dc.b    %01111110
	dc.b    %00111100
	dc.b    %00011000

cur:
	dc.b    %11111111
	dc.b    %11111111
	dc.b    %11111111
	dc.b    %11111111
	dc.b    %11111111
	dc.b    %11111111
	dc.b    %11111111
	dc.b    %11111111

_comment:	dc.b "Fliptile by Martin Zeppenfeld",0
	end